from typing import Generic, TypeVar, Optional, Union
from dataclasses import dataclass, field

T = TypeVar('T')

@dataclass
class MyList(Generic[T]):
    
    def __post_init__(self, ):
        self.__internal_list: list[T] = field(default_factory=list)
        self.__length: int = 0

    def append(self, value: T):
        self.__internal_list += [value]
        self.__length += 1

    def remove(self, value: T):
        if value in self.__internal_list:
            self.__internal_list.remove(value)
    
    def get(self, i: int) -> Optional[T]:
        if i < len(self):
            return self[i]
        return None

    def __len__(self) -> int:
        return self.__length

    def __getitem__(self, i: int) -> T:
        return self.__internal_list[i]

@dataclass
class MyListNew[T]:
    
    def __post_init__(self, ):
        self.__internal_list: list[T] = field(default_factory=list)
        self.__length: int = 0

    def append(self, value: T):
        self.__internal_list += [value]
        self.__length += 1

    def remove(self, value: T):
        if value in self.__internal_list:
            self.__internal_list.remove(value)
    
    def get(self, i: int) -> Optional[T]:
        if i < len(self):
            return self[i]
        return None

    def __len__(self) -> int:
        return self.__length

    def __getitem__(self, i: int) -> T:
        return self.__internal_list[i]
    
    
RealNumber = Union[int, float]

def add(x: RealNumber, y: RealNumber) -> RealNumber:
    return x + y

type NewRealNumber = int | float

# sonst sieht alles gleich aus
def new_add(x: NewRealNumber, y: NewRealNumber) -> NewRealNumber:
    return x + y